# first install the dependency
# pip install pyTelegramBotAPI

import telebot
import requests
import json
import random

# Prompting the user to input necessary variables
apitoken = input("Enter your Telegram API token: ")
apipath = input("Enter the Comindware Business Application Platform API path: ")
login = input("Enter your Comindware Business Application Platform username: ")
password = input("Enter your password: ")

# Creating a bot instance
bot = telebot.TeleBot(apitoken)

# Function to handle '/start' command
@bot.message_handler(commands=['start'])
def handle_start(message):
    bot.reply_to(message, "Бот запущен")

# Function to handle normal messages
@bot.message_handler(func=lambda message: True)
def handle_message(message):
    chat_id = message.chat.id

    # Function to fetch data from the given OA_system_name
    def get_data(OA_system_name):
        response = requests.get(f"{apipath}/solution/{OA_system_name}", auth=(login, password))
        return response.text

    # Function to extract value from JSON data
    def value_from_json(data, attribute_name, chat_id):
        users = json.loads(data)
        for user in users:
            if user.get("ChatID", "") == chat_id:
                return user.get(attribute_name, "")
        return ""

    data = get_data("Sotrudniki")
    if value_from_json(data, "ChatID", str(chat_id)) == "":
        if "@" in message.text:
            users = json.loads(data)
            for user in users:
                current_email = user.get("mbox", "")
                if current_email.lower() == message.text.lower():
                    account_id = user.get("id", "")
                    code = ''.join(random.choices("0123456789", k=4))
                    data_ = {
                        "op.13": str(chat_id) + "_NA",
                        "op.14": code
                    }
                    # Updating user data
                    url = f"{apipath}/system/TeamNetwork/ObjectService/Edit"
                    payload = {
                        "objectId": account_id,
                        "objectData": data_
                    }
                    headers = {"Content-Type": "application/json"}
                    requests.post(url, json=payload, auth=(login, password), headers=headers)

                    # Sending verification code
                    url = f"{apipath}/system/Process/ProcessObjectService/Create1"
                    payload = {
                        "op.23": code,
                        "op.24": current_email
                    }
                    data = {
                        "processAppId": "pa.3",
                        "objectName": None,
                        "syncActivityQuantity": 2,
                        "objectData": payload
                    }
                    headers = {"Content-Type": "application/json"}
                    requests.post(url, json=data, auth=(login, password), headers=headers)
                    bot.send_message(chat_id, "На указанную почту отправлено письмо с 4-значным кодом, введите его ниже для авторизации")
        elif len(message.text) == 4:
            value = value_from_json(data, "Proverochnyykod", str(chat_id) + "_NA")
            if message.text == value:
                value_id = value_from_json(data, "id", str(chat_id) + "_NA")
                data_ = {
                    "op.13": str(chat_id),
                    "op.14": None
                }
                # Updating user data
                url = f"{apipath}/system/TeamNetwork/ObjectService/Edit"
                payload = {
                    "objectId": value_id,
                    "objectData": data_
                }
                headers = {"Content-Type": "application/json"}
                requests.post(url, json=payload, auth=(login, password), headers=headers)
                bot.send_message(chat_id, "Вы успешно авторизованы")
        else:
            bot.send_message(chat_id, "Укажите адрес эл. почты для авторизации")
    else:
        name = value_from_json(data, "fullName", str(chat_id))
        bot.send_message(chat_id, f"Добрый день, {name}! Вы успешно авторизованы")

# Starting the bot
bot.polling()
